#!/usr/bin/env python3
from starlette.routing import Router, Route
from starlette.responses import JSONResponse
from .config import config
from pyheatpump.db import sql

from pyheatpump.models import *

def get_variable_values(request):
    res = {}
    for var_type_id, var_type in VariableType.getall().items():
        res[var_type_id] = {}
        for address, value in var_type.get_variables_values().items():
            res[var_type_id][address] = value

    return JSONResponse(res)


ROUTES=[
    Route('/', get_variable_values, methods=['GET'])
]

app = Router(routes=ROUTES)

if __name__ == '__main__':
    uvicorn.run('pyHeatpump:heatpump.app',
        host='127.0.0.1',
        port=8000)
